ALLEN INSTITUTE

# bmtk.simulator.pointnet.modules package

## Submodules

## bmtk.simulator.pointnet.modules.ecephys_module module

class bmtk.simulator.pointnet.modules.ecephys_module.PointECEphysUnitsModule(name, **kwargs)

  Bases: `ECEphysUnitsModule`

  initialize(sim)

    Will be called once at the beginning of the simulation run, after the network and simulation parameters have all been finalized.

    Parameters:

      sim – Simulation object

bmtk.simulator.pointnet.modules.ecephys_module.set_spikes(node_id, nest_obj, spike_trains)

bmtk.simulator.pointnet.modules.ecephys_module.set_spikes_nest2(node_id, nest_obj, spike_trains)

bmtk.simulator.pointnet.modules.ecephys_module.set_spikes_nest3(node_id, nest_obj, spike_trains)

## bmtk.simulator.pointnet.modules.iclamp module

class bmtk.simulator.pointnet.modules.iclamp.IClampMod(input_type, **mod_args)

  Bases: `IClampMod`

  initialize(sim)

    Creates a NEST current clamp (eg step-generator) and attaches it to the given cells.

## bmtk.simulator.pointnet.modules.multimeter_reporter module

class bmtk.simulator.pointnet.modules.multimeter_reporter.MultimeterMod(tmp_dir, file_name, variable_name, cells, tstart=None, tstop=None, interval=None, to_h5=True, delete_dat=True, **opt_params)

  Bases: `SimulatorMod`

  finalize(sim)

    Call once at the very end of the simulation.

    Parameters:

      sim – Simulation object

  initialize(sim)

    Will be called once at the beginning of the simulation run, after the network and simulation parameters have all been finalized.

    Parameters:

      sim – Simulation object

bmtk.simulator.pointnet.modules.multimeter_reporter.create_multimeter(tstart, tstop, variable_name, label)

bmtk.simulator.pointnet.modules.multimeter_reporter.create_multimeter_nest2(tstart, tstop, variable_name, label)

bmtk.simulator.pointnet.modules.multimeter_reporter.create_multimeter_nest3(tstart, tstop, variable_name, label)

bmtk.simulator.pointnet.modules.multimeter_reporter.read_dat(dat_file, variable_name)

bmtk.simulator.pointnet.modules.multimeter_reporter.read_dat_nest2(dat_file, variable_name)

bmtk.simulator.pointnet.modules.multimeter_reporter.read_dat_nest3(dat_file, variable_name)

## bmtk.simulator.pointnet.modules.record_spikes module

class bmtk.simulator.pointnet.modules.record_spikes.SpikesMod(tmp_dir, spikes_file_csv=None, spikes_file=None, spikes_file_nwb=None, spikes_sort_order=None, cache_to_disk=True, compression='gzip')

  Bases: `SimulatorMod`

  Module use for saving spikes

  finalize(sim)

    Call once at the very end of the simulation.

    Parameters:

      sim – Simulation object

  initialize(sim)

    Will be called once at the beginning of the simulation run, after the network and simulation parameters have all been finalized.

    Parameters:

      sim – Simulation object

bmtk.simulator.pointnet.modules.record_spikes.create_spike_detector(label)

bmtk.simulator.pointnet.modules.record_spikes.create_spike_detector_nest2(label)

bmtk.simulator.pointnet.modules.record_spikes.create_spike_detector_nest3(label)

bmtk.simulator.pointnet.modules.record_spikes.read_spikes_file(spike_trains_writer, gid_map, label)

bmtk.simulator.pointnet.modules.record_spikes.read_spikes_file_nest2(spike_trains_writer, gid_map, label)

bmtk.simulator.pointnet.modules.record_spikes.read_spikes_file_nest3(spike_trains_writer, gid_map, label)

## bmtk.simulator.pointnet.modules.sim_module module

class bmtk.simulator.pointnet.modules.sim_module.SimulatorMod

  Bases: `object`

  Class for writing custom bionet functions that will be called during the simulation. To use overwrite one or more of the following methods in a subclass, and bionet will call the function at the appropiate time.

  To call during a simulation:

    … sim = Simulation(…) mymod = MyModule(…) sim.add_mod(mymod) sim.run()

  block(sim, block_interval)

    This method is called once after every block of time, as specified by the configuration.

    Unlike the step method which is called during every time-step, the block method will typically be called only a few times over the entire simulation. The block method is preferable for accessing and saving to the disk, summing up existing data, or similar functionality

    Parameters:

      - sim – Simulation object

      - block_interval – The time interval (tstep_start, tstep_end) for which the block is being called on.

  finalize(sim)

    Call once at the very end of the simulation.

    Parameters:

      sim – Simulation object

  initialize(sim)

    Will be called once at the beginning of the simulation run, after the network and simulation parameters have all been finalized.

    Parameters:

      sim – Simulation object

  preload(sim)

    Will be called once at the beginning of the simulation run before network is loaded

    Parameters:

      sim – Simulation object

  step(sim, tstep)

    Called on every single time step (dt).

    The step method is used for anything that should be recorded or changed continously. dt is determined during the setup, and the sim parameter can be used to access simulation, network and individual cell properties

    Parameters:

      - sim – Simulation object.

      - tstep – The decrete time-step

## bmtk.simulator.pointnet.modules.spikes_inputs module

class bmtk.simulator.pointnet.modules.spikes_inputs.SpikesInputsMod(name, input_type, module, **kwargs)

  Bases: `SimulatorMod`

  initialize(sim)

    Will be called once at the beginning of the simulation run, after the network and simulation parameters have all been finalized.

    Parameters:

      sim – Simulation object

## bmtk.simulator.pointnet.modules.weight_recorder module

class bmtk.simulator.pointnet.modules.weight_recorder.WeightRecorder(name, nest_model, model_template, file_name, output_dir='.', **kwargs)

  Bases: `SimulatorMod`

  finalize(sim)

    Call once at the very end of the simulation.

    Parameters:

      sim – Simulation object

  preload(sim)

    Will be called once at the beginning of the simulation run before network is loaded

    Parameters:

      sim – Simulation object

## Module contents